require "json"

File.open("citylots.json") do |f|
  collection = FeatureCollection.from_json(f)
  puts collection.features.size
end

class FeatureCollection
  JSON.mapping({
    features: Array(Feature),
  })
end

class Feature
  JSON.mapping({
    properties: Properties,
  })
end

class Properties
  JSON.mapping(
    mapblklot: {type: String, key: "MAPBLKLOT"},
    blklot: {type: String, key: "BLKLOT"},
    block_num: {type: String, key: "BLOCK_NUM"},
    lot_num: {type: String, key: "LOT_NUM"},
    from_st: {type: String?, key: "FROM_ST"},
    to_st: {type: String?, key: "TO_ST"},
    street: {type: String?, key: "STREET"},
    st_type: {type: String?, key: "ST_TYPE"},
    odd_even: {type: String?, key: "ODD_EVEN"}
  )
end
