@[Link("lua")]
lib LibLua
  # #define LUA_MULTRET	(-1)
  MULTRET = -1

  type State = Void*
  alias Func = State -> Int32

  fun newstate = luaL_newstate : State
  fun openlibs = luaL_openlibs(l : State) : Void

  # #define lua_pcall(L,n,r,f)	lua_pcallk(L, (n), (r), (f), 0, NULL)
  # #define luaL_dostring(L, s) \
  #   (luaL_loadstring(L, s) || lua_pcall(L, 0, LUA_MULTRET, 0))
  fun loadstring = luaL_loadstring(l : State, s : UInt8*) : Int32
  fun pcallk = lua_pcallk(l : State, nargs : Int32, nret : Int32, errfunc : Int32, ctx : Int32, k : Func) : Int32
  fun close = lua_close(l : State) : Void
end

def dostring(lua, s)
  if (result = LibLua.loadstring(lua, s)) == 0
    result = LibLua.pcallk(lua, 0, LibLua::MULTRET, 0, 0, nil)
  end
  result
end

lua = LibLua.newstate
LibLua.openlibs(lua)

result = dostring(lua, "print('hello world')")
puts "dostring : #{result}"

LibLua.close(lua)
