@[Link("lua")]
lib LibLua
  MULTRET = -1

  type State = Void*
  alias Func = State -> Int32

  fun newstate = luaL_newstate : State
  fun openlibs = luaL_openlibs(l : State) : Void

  fun loadstring = luaL_loadstring(l : State, s : UInt8*) : Int32
  fun loadfilex = luaL_loadfilex(l : State, filename : UInt8*, mode : UInt8*) : Int32
  fun pcallk = lua_pcallk(l : State, nargs : Int32, nret : Int32, errfunc : Int32, ctx : Int32, k : Func) : Int32

  fun close = lua_close(l : State) : Void
end

def dostring(lua, s)
  if (result = LibLua.loadstring(lua, s)) == 0
    result = LibLua.pcallk(lua, 0, LibLua::MULTRET, 0, 0, nil)
  end
  result
end

def dofile(lua, filename)
  if (result = LibLua.loadfilex(lua, filename, nil)) == 0
    result = LibLua.pcallk(lua, 0, LibLua::MULTRET, 0, 0, nil)
  end
  result
end

lua = LibLua.newstate
LibLua.openlibs(lua)

result = dofile(lua, "sample.lua")
puts "dofile : #{result}"

result = dostring(lua, File.new("sample.lua").gets_to_end)
puts "dostring : #{result}"

LibLua.close(lua)
