@[Link("lua")]
lib LibLua
  MULTRET = -1

  type State = Void*
  alias Func = State -> Int32
  alias Integer = LibC::Long

  fun newstate = luaL_newstate : State
  fun openlibs = luaL_openlibs(l : State) : Void

  fun loadstring = luaL_loadstring(l : State, s : UInt8*) : Int32
  fun callk = lua_callk(l : State, nargs : Int32, nret : Int32, ctx : Int32, k : Func) : Int32
  fun pcallk = lua_pcallk(l : State, nargs : Int32, nret : Int32, errfunc : Int32, ctx : Int32, k : Func) : Int32

  fun getglobal = lua_getglobal(l : State, s : UInt8*) : Void
  fun pushinteger = lua_pushinteger(l : State, n : Integer) : Void
  fun tointegerx = lua_tointegerx(l : State, idx : Int32, isnum : Int32*) : Integer
  fun close = lua_close(l : State) : Void
end

def dostring(lua, s)
  if (result = LibLua.loadstring(lua, s)) == 0
    result = LibLua.pcallk(lua, 0, LibLua::MULTRET, 0, 0, nil)
  end
  result
end

lua = LibLua.newstate

result = dostring(lua, "function addition(x,y) return x+y end")
if result == 0
  LibLua.getglobal(lua, "addition")
  LibLua.pushinteger(lua, 5)
  LibLua.pushinteger(lua, 3)
  pp LibLua.callk(lua, 2, 1, 0, nil)
  x = LibLua.tointegerx(lua, -1, out isnum)
  pp isnum
  pp x
else
  puts "Failed to execute string"
end

LibLua.close(lua)
