def dostring(lua, s)
  if (result = LibLua.loadstring(lua, s)) == 0
    result = LibLua.pcallk(lua, 0, LibLua::MULTRET, 0, 0, nil)
  end
  result
end

def lua_addition(lua)
  x = LibLua.tointegerx(lua, 1, nil)
  y = LibLua.tointegerx(lua, 2, nil)
  LibLua.pushinteger(lua, x + y)
  puts "adding for Lua #{x} + #{y} = #{x + y}"
  return 1
end

lua = LibLua.newstate
LibLua.openlibs(lua)

LibLua.pushcclosure(lua, ->lua_addition, 0)
LibLua.setglobal(lua, "addition")

result = dostring(lua, "x = addition(3,5); print(x)")
if result != 0
  puts "Failed to execute string"
end

LibLua.close(lua)

@[Link("lua")]
lib LibLua
  MULTRET = -1

  type State = Void*
  alias Func = State -> Int32
  alias Integer = LibC::Long

  fun newstate = luaL_newstate : State
  fun openlibs = luaL_openlibs(l : State) : Void

  fun loadstring = luaL_loadstring(l : State, s : UInt8*) : Int32
  fun callk = lua_callk(l : State, nargs : Int32, nret : Int32, ctx : Int32, k : Func) : Int32
  fun pcallk = lua_pcallk(l : State, nargs : Int32, nret : Int32, errfunc : Int32, ctx : Int32, k : Func) : Int32

  fun getglobal = lua_getglobal(l : State, name : UInt8*) : Void
  fun setglobal = lua_setglobal(l : State, name : UInt8*) : Void
  fun pushinteger = lua_pushinteger(l : State, n : Integer) : Void
  fun pushcclosure = lua_pushcclosure(l : State, f : Func, nup : Int32) : Void
  fun tointegerx = lua_tointegerx(l : State, idx : Int32, isnum : Int32*) : Integer

  fun close = lua_close(l : State) : Void
end
