require "http/client"
require "json"
require "./secrets"

class SearchResult
  JSON.mapping(
    total_count: Int32,
    items: Array(Repository)
  )
end

class User
  JSON.mapping(
    login: String
  )
end

class Repository
  JSON.mapping(
    id: Int32,
    name: String,
    full_name: String,
    owner: User,
    stargazers_count: Int32
  )
end

client = HTTP::Client.new("api.github.com", 443, true)
client.before_request do |req|
  req.headers["Authorization"] = "token #{GITHUB_TOKEN}"
end

reply = client.get("/search/repositories?q=crystal")

result = SearchResult.from_json(reply.body)
result.items.each do |repo|
  puts "#{repo.full_name} - #{repo.stargazers_count}"
end
